package manage

import (
	"demo/configs"
	"demo/data/domain"
	"demo/data/domain/vo"
)

func GetByIdGoodsType(id int) (domain.GoodsType, error) {
	var goodsType domain.GoodsType
	_, err := configs.Engine.Where("id = ?", id).Get(&goodsType)
	if err != nil {
		return goodsType, err
	}
	return goodsType, nil
}

func GetInIdListGoodsType(ids []int) ([]domain.GoodsType, error) {
	rows, err := configs.Engine.In("id", ids).Rows(&domain.GoodsType{})
	if err != nil {
		return make([]domain.GoodsType, 0), err
	}
	defer rows.Close()
	var list []domain.GoodsType
	for rows.Next() {
		var u domain.GoodsType
		list = append(list, u)
	}
	return list, nil
}

func GetListGoodsType(goodsType domain.GoodsType, pageNum, pageSize int) (vo.BaseListVo, error) {
	rows, err := configs.Engine.Limit(pageSize, (pageNum-1)*pageSize).Desc("id").Rows(&goodsType)
	var vo vo.BaseListVo
	if err != nil {
		return vo, err
	}
	vo.PageNum = pageNum
	vo.PageSize = pageSize
	vo.List = make([]any, 0)
	for rows.Next() {
		var u domain.GoodsType
		rows.Scan(&u)
		vo.List = append(vo.List, u)
	}
	//查询数量
	count, err := configs.Engine.Count(&goodsType)
	vo.Total = int(count)
	return vo, nil
}

func SaveGoodsType(goodsType *domain.GoodsType) (domain.GoodsType, error) {
	_, err := configs.Engine.Insert(&goodsType)
	if err != nil {
		return *goodsType, err
	}
	return *goodsType, nil
}

func SetGoodsType(goodsTypeMap map[string]interface{}, id int) (domain.GoodsType, bool, error) {
	var goodsType domain.GoodsType
	_, err := configs.Engine.Table("goods_type").Where("id = ?", id).Update(goodsTypeMap)
	if err != nil {
		return goodsType, false, err
	}
	return goodsType, true, nil
}

func DeleteGoodsType(goodsType domain.GoodsType) bool {
	i, err := configs.Engine.Where("id = ?", goodsType.Id).Delete(&goodsType)
	if err != nil {
		return false
	}
	return i > 0
}
